
Usage:

kc.sh update-compatibility metadata [OPTIONS]
Stores the metadata necessary to determine if a configuration is compatible.

Options:

--file <FILE>        The file path to store the metadata. It is stored in the JSON format.
-h, --help           This help message.
--help-all           This same help message but with additional options.
--optimized          Use this option to achieve an optimal startup time if you have previously
                       built a server image using the 'build' command.
-v, --verbose        Print out error details when running this command.

Cache:

--cache <type>       Defines the cache mechanism for high-availability. By default in production
                       mode, a 'ispn' cache is used to create a cluster between multiple server
                       nodes. By default in development mode, a 'local' cache disables clustering
                       and is intended for development and testing purposes. Possible values are:
                       ispn, local. Default: ispn.
--cache-config-file <file>
                     Defines the file from which cache configuration should be loaded from. The
                       configuration file is relative to the 'conf/' directory.
--cache-config-mutate <true|false>
                     Determines whether changes to the default cache configurations are allowed.
                       This is only recommended for advanced use-cases where the default cache
                       configurations are proven to be problematic. The only supported way to
                       change the default cache configurations is via the other 'cache-...'
                       options. Default: false.
--cache-embedded-authorization-max-count <max-count>
                     The maximum number of entries that can be stored in-memory by the
                       authorization cache.
--cache-embedded-client-sessions-max-count <max-count>
                     The maximum number of entries that can be stored in-memory by the
                       clientSessions cache. Available only when embedded Infinispan clusters
                       configured.
--cache-embedded-crl-max-count <max-count>
                     The maximum number of entries that can be stored in-memory by the crl cache.
--cache-embedded-keys-max-count <max-count>
                     The maximum number of entries that can be stored in-memory by the keys cache.
--cache-embedded-mtls-enabled <true|false>
                     Encrypts the network communication between Keycloak servers. If no additional
                       parameters about a keystore and truststore are provided, ephemeral key pairs
                       and certificates are created and rotated automatically, which is recommended
                       for standard setups. Default: true. Available only when a TCP based
                       cache-stack is used.
--cache-embedded-mtls-key-store-file <file>
                     The Keystore file path. The Keystore must contain the certificate to use by
                       the TLS protocol. By default, it looks up 'cache-mtls-keystore.p12' under
                       conf/ directory. Available only when property 'cache-embedded-mtls-enabled'
                       is enabled.
--cache-embedded-mtls-key-store-password <password>
                     The password to access the Keystore. Available only when property
                       'cache-embedded-mtls-enabled' is enabled.
--cache-embedded-mtls-rotation-interval-days <days>
                     Rotation period in days of automatic JGroups MTLS certificates. Default: 30.
                       Available only when property 'cache-embedded-mtls-enabled' is enabled.
--cache-embedded-mtls-trust-store-file <file>
                     The Truststore file path. It should contain the trusted certificates or the
                       Certificate Authority that signed the certificates. By default, it lookup
                       'cache-mtls-truststore.p12' under conf/ directory. Available only when
                       property 'cache-embedded-mtls-enabled' is enabled.
--cache-embedded-mtls-trust-store-password <password>
                     The password to access the Truststore. Available only when property
                       'cache-embedded-mtls-enabled' is enabled.
--cache-embedded-network-bind-address <address>
                     IP address used by clustering transport. By default, SITE_LOCAL is used.
                       Available only when Infinispan clustered embedded is enabled.
--cache-embedded-network-bind-port <port>
                     The Port the clustering transport will bind to. By default, port 7800 is used.
                       Available only when Infinispan clustered embedded is enabled.
--cache-embedded-network-external-address <address>
                     IP address that other instances in the cluster should use to contact this
                       node. Set only if it is different to cache-embedded-network-bind-address,
                       for example when this instance is behind a firewall. Available only when
                       Infinispan clustered embedded is enabled.
--cache-embedded-network-external-port <port>
                     Port that other instances in the cluster should use to contact this node. Set
                       only if it is different to cache-embedded-network-bind-port, for example
                       when this instance is behind a firewall Available only when Infinispan
                       clustered embedded is enabled.
--cache-embedded-offline-client-sessions-max-count <max-count>
                     The maximum number of entries that can be stored in-memory by the
                       offlineClientSessions cache. Available only when embedded Infinispan
                       clusters configured.
--cache-embedded-offline-sessions-max-count <max-count>
                     The maximum number of entries that can be stored in-memory by the
                       offlineSessions cache. Available only when embedded Infinispan clusters
                       configured.
--cache-embedded-realms-max-count <max-count>
                     The maximum number of entries that can be stored in-memory by the realms cache.
--cache-embedded-sessions-max-count <max-count>
                     The maximum number of entries that can be stored in-memory by the sessions
                       cache. Available only when embedded Infinispan clusters configured.
--cache-embedded-users-max-count <max-count>
                     The maximum number of entries that can be stored in-memory by the users cache.
--cache-remote-host <hostname>
                     The hostname of the external Infinispan cluster. Available only when feature
                       'multi-site' or 'clusterless' is set. Required when feature 'multi-site' or
                       'clusterless' is set.
--cache-stack <stack>
                     Define the default stack to use for cluster communication and node discovery.
                       Defaults to 'jdbc-ping' if not set. Possible values are: jdbc-ping,
                       kubernetes (deprecated), jdbc-ping-udp (deprecated), tcp (deprecated), udp
                       (deprecated), ec2 (deprecated), azure (deprecated), google (deprecated), or
                       a custom one. Available only when 'cache' type is set to 'ispn'.

Config:

--config-keystore <config-keystore>
                     Specifies a path to the KeyStore Configuration Source.
--config-keystore-password <config-keystore-password>
                     Specifies a password to the KeyStore Configuration Source.
--config-keystore-type <config-keystore-type>
                     Specifies a type of the KeyStore Configuration Source. Default: PKCS12.

Database:

--db <vendor>        The database vendor. In production mode the default value of 'dev-file' is
                       deprecated, you should explicitly specify the db instead. Possible values
                       are: dev-file, dev-mem, mariadb, mssql, mysql, oracle, postgres, tidb.
                       Default: dev-file.
--db-debug-jpql <true|false>
                     Add JPQL information as comments to SQL statements to debug JPA SQL statement
                       generation. Default: false.
--db-driver <driver> The fully qualified class name of the JDBC driver. If not set, a default
                       driver is set accordingly to the chosen database.
--db-log-slow-queries-threshold <milliseconds>
                     Log SQL statements slower than the configured threshold with logger org.
                       hibernate.SQL_SLOW and log-level info. Default: 10000.
--db-password <password>
                     The password of the database user.
--db-pool-initial-size <size>
                     The initial size of the connection pool.
--db-pool-max-lifetime <duration>
                     The maximum time a connection remains in the pool, after which it will be
                       closed upon return and replaced as necessary. May be an ISO 8601 duration
                       value, an integer number of seconds, or an integer followed by one of [ms,
                       h, m, s, d].
--db-pool-max-size <size>
                     The maximum size of the connection pool. Default: 100.
--db-pool-min-size <size>
                     The minimal size of the connection pool.
--db-schema <schema> The database schema to be used.
--db-url <jdbc-url>  The full database JDBC URL. If not provided, a default URL is set based on the
                       selected database vendor. For instance, if using 'postgres', the default
                       JDBC URL would be 'jdbc:postgresql://localhost/keycloak'.
--db-url-database <dbname>
                     Sets the database name of the default JDBC URL of the chosen vendor. If the
                       `db-url` option is set, this option is ignored.
--db-url-host <hostname>
                     Sets the hostname of the default JDBC URL of the chosen vendor. If the
                       `db-url` option is set, this option is ignored.
--db-url-port <port> Sets the port of the default JDBC URL of the chosen vendor. If the `db-url`
                       option is set, this option is ignored.
--db-url-properties <properties>
                     Sets the properties of the default JDBC URL of the chosen vendor. Make sure to
                       set the properties accordingly to the format expected by the database
                       vendor, as well as appending the right character at the beginning of this
                       property value. If the `db-url` option is set, this option is ignored.
--db-username <username>
                     The username of the database user.

Database - additional datasources:

--db-debug-jpql-<datasource> <true|false>
                     Used for named <datasource>. Add JPQL information as comments to SQL
                       statements to debug JPA SQL statement generation. Default: false.
--db-driver-<datasource> <driver>
                     Used for named <datasource>. The fully qualified class name of the JDBC
                       driver. If not set, a default driver is set accordingly to the chosen
                       database.
--db-enabled-<datasource> <true|false>
                     If the named datasource <datasource> should be enabled at runtime. Default:
                       true.
--db-kind-<datasource> <vendor>
                     Used for named <datasource>. The database vendor. In production mode the
                       default value of 'dev-file' is deprecated, you should explicitly specify the
                       db instead. Possible values are: dev-file, dev-mem, mariadb, mssql, mysql,
                       oracle, postgres, tidb.
--db-log-slow-queries-threshold-<datasource> <milliseconds>
                     Used for named <datasource>. Log SQL statements slower than the configured
                       threshold with logger org.hibernate.SQL_SLOW and log-level info. Default:
                       10000.
--db-password-<datasource> <password>
                     Used for named <datasource>. The password of the database user.
--db-pool-initial-size-<datasource> <size>
                     Used for named <datasource>. The initial size of the connection pool.
--db-pool-max-size-<datasource> <size>
                     Used for named <datasource>. The maximum size of the connection pool. Default:
                       100.
--db-pool-min-size-<datasource> <size>
                     Used for named <datasource>. The minimal size of the connection pool.
--db-schema-<datasource> <schema>
                     Used for named <datasource>. The database schema to be used.
--db-url-database-<datasource> <dbname>
                     Used for named <datasource>. Sets the database name of the default JDBC URL of
                       the chosen vendor. If the `db-url` option is set, this option is ignored.
--db-url-full-<datasource> <jdbc-url>
                     Used for named <datasource>. The full database JDBC URL. If not provided, a
                       default URL is set based on the selected database vendor. For instance, if
                       using 'postgres', the default JDBC URL would be 'jdbc:postgresql:
                       //localhost/keycloak'.
--db-url-host-<datasource> <hostname>
                     Used for named <datasource>. Sets the hostname of the default JDBC URL of the
                       chosen vendor. If the `db-url` option is set, this option is ignored.
--db-url-port-<datasource> <port>
                     Used for named <datasource>. Sets the port of the default JDBC URL of the
                       chosen vendor. If the `db-url` option is set, this option is ignored.
--db-url-properties-<datasource> <properties>
                     Used for named <datasource>. Sets the properties of the default JDBC URL of
                       the chosen vendor. Make sure to set the properties accordingly to the format
                       expected by the database vendor, as well as appending the right character at
                       the beginning of this property value. If the `db-url` option is set, this
                       option is ignored.
--db-username-<datasource> <username>
                     Used for named <datasource>. The username of the database user.

Transaction:

--transaction-xa-enabled <true|false>
                     If set to true, XA datasources will be used. Default: false.
--transaction-xa-enabled-<datasource> <true|false>
                     If set to true, XA for <datasource> datasource will be used. Default: true.

Feature:

--feature-<name> <enabled|disabled|vX(X is version)>
                     Enable/Disable specific feature <feature>. It takes precedence over the
                       'features', and 'features-disabled' options. Possible values are: 'enabled',
                       'disabled', or specific version (lowercase) that will be enabled (f.e. 'v2')
--features <feature> Enables a set of one or more features. Possible values are: <...>.
--features-disabled <feature>
                     Disables a set of one or more features. Possible values are: <...>.

Hostname v2:

--hostname <hostname|URL>
                     Address at which is the server exposed. Can be a full URL, or just a hostname.
                       When only hostname is provided, scheme, port and context path are resolved
                       from the request. Available only when hostname:v2 feature is enabled.
--hostname-admin <URL>
                     Address for accessing the administration console. Use this option if you are
                       exposing the administration console using a reverse proxy on a different
                       address than specified in the 'hostname' option. Available only when
                       hostname:v2 feature is enabled.
--hostname-backchannel-dynamic <true|false>
                     Enables dynamic resolving of backchannel URLs, including hostname, scheme,
                       port and context path. Set to true if your application accesses Keycloak via
                       a private network. If set to true, 'hostname' option needs to be specified
                       as a full URL. Default: false. Available only when hostname:v2 feature is
                       enabled.
--hostname-debug <true|false>
                     Toggles the hostname debug page that is accessible at
                       /realms/master/hostname-debug. Default: false. Available only when hostname:
                       v2 feature is enabled.
--hostname-strict <true|false>
                     Disables dynamically resolving the hostname from request headers. Should
                       always be set to true in production, unless your reverse proxy overwrites
                       the Host header. If enabled, the 'hostname' option needs to be specified.
                       Default: true. Available only when hostname:v2 feature is enabled.

HTTP(S):

--http-accept-non-normalized-paths <true|false>
                     DEPRECATED. If the server should accept paths that are not normalized
                       according to RFC3986 or that contain a double slash ('//'). While accepting
                       those requests might be relevant for legacy applications, it is recommended
                       to disable it to allow for more concise URL filtering. Default: false.
--http-enabled <true|false>
                     Enables the HTTP listener. Enabled by default in development mode. Typically
                       not enabled in production unless the server is fronted by a TLS termination
                       proxy. Default: false.
--http-host <host>   The HTTP Host. By default, Keycloak binds to all network addresses (0.0.0.0),
                       which means the server may be accessible from other machines on your
                       network. For local development, you can restrict access to localhost only by
                       setting this to 127.0.0.1. Default: 0.0.0.0.
--http-max-queued-requests <requests>
                     Maximum number of queued HTTP requests. Use this to shed load in an overload
                       situation. Excess requests will return a "503 Server not Available" response.
--http-pool-max-threads <threads>
                     The maximum number of threads. If this is not specified then it will be
                       automatically sized to the greater of 4 * the number of available processors
                       and 50. For example if there are 4 processors the max threads will be 50. If
                       there are 48 processors it will be 192.
--http-port <port>   The used HTTP port. Default: 8080.
--http-relative-path <path>
                     Set the path relative to '/' for serving resources. The path must start with a
                       '/'. Default: /.
--https-certificate-file <file>
                     The file path to a server certificate or certificate chain in PEM format.
--https-certificate-key-file <file>
                     The file path to a private key in PEM format.
--https-certificates-reload-period <reload period>
                     Interval on which to reload key store, trust store, and certificate files
                       referenced by https-* options. May be an ISO 8601 duration value, an integer
                       number of seconds, or an integer followed by one of [ms, h, m, s, d]. Must
                       be greater than 30 seconds. Use -1 to disable. Default: 1h.
--https-cipher-suites <ciphers>
                     The cipher suites to use. If none is given, a reasonable default is selected.
--https-client-auth <auth>
                     Configures the server to require/request client authentication. Possible
                       values are: none, request, required. Default: none.
--https-key-store-file <file>
                     The key store which holds the certificate information instead of specifying
                       separate files.
--https-key-store-password <password>
                     The password of the key store file. Default: password.
--https-key-store-type <type>
                     The type of the key store file. If not given, the type is automatically
                       detected based on the file extension. If 'fips-mode' is set to 'strict' and
                       no value is set, it defaults to 'BCFKS'.
--https-port <port>  The used HTTPS port. Default: 8443.
--https-protocols <protocols>
                     The list of protocols to explicitly enable. If a value is not supported by the
                       JRE / security configuration, it will be silently ignored. Possible values
                       are: TLSv1.3, TLSv1.2, or a custom one. Default: TLSv1.3,TLSv1.2.
--https-trust-store-file <file>
                     The trust store which holds the certificate information of the certificates to
                       trust.
--https-trust-store-password <password>
                     The password of the trust store file.
--https-trust-store-type <type>
                     The type of the trust store file. If not given, the type is automatically
                       detected based on the file extension. If 'fips-mode' is set to 'strict' and
                       no value is set, it defaults to 'BCFKS'.

HTTP Access log:

--http-access-log-enabled <true|false>
                     If HTTP access logging is enabled. By default this will log records in
                       console. Default: false.

Health:

--health-enabled <true|false>
                     If the server should expose health check endpoints. If enabled, health checks
                       are available at the '/health', '/health/ready' and '/health/live'
                       endpoints. Default: false.

Management:

--http-management-port <port>
                     Port of the management interface. Relevant only when something is exposed on
                       the management interface - see the guide for details. Default: 9000.
--http-management-relative-path <path>
                     Set the path relative to '/' for serving resources from management interface.
                       The path must start with a '/'. If not given, the value is inherited from
                       HTTP options. Relevant only when something is exposed on the management
                       interface - see the guide for details. Default: /.
--http-management-scheme <scheme>
                     Configures the management interface scheme. If 'inherited', the management
                       interface will inherit the HTTPS settings of the main interface. If 'http',
                       the management interface will be accessible via HTTP - it will not inherit
                       HTTPS settings and cannot be configured for HTTPS. Possible values are:
                       http, inherited. Default: inherited.
--https-management-certificate-file <file>
                     The file path to a server certificate or certificate chain in PEM format for
                       the management server. If not given, the value is inherited from HTTP
                       options. Relevant only when something is exposed on the management interface
                       - see the guide for details. Available only when http-management-scheme is
                       inherited.
--https-management-certificate-key-file <file>
                     The file path to a private key in PEM format for the management server. If not
                       given, the value is inherited from HTTP options. Relevant only when
                       something is exposed on the management interface - see the guide for
                       details. Available only when http-management-scheme is inherited.
--https-management-certificates-reload-period <reload period>
                     Interval on which to reload key store, trust store, and certificate files
                       referenced by https-management-* options for the management server. May be
                       an ISO 8601 duration value, an integer number of seconds, or an integer
                       followed by one of [ms, h, m, s, d]. Must be greater than 30 seconds. Use -1
                       to disable. If not given, the value is inherited from HTTP options. Relevant
                       only when something is exposed on the management interface - see the guide
                       for details. Default: 1h. Available only when http-management-scheme is
                       inherited.
--https-management-client-auth <auth>
                     Configures the management interface to require/request client authentication.
                       If not given, the value is inherited from HTTP options. Relevant only when
                       something is exposed on the management interface - see the guide for
                       details. Possible values are: none, request, required. Default: none.
--https-management-key-store-file <file>
                     The key store which holds the certificate information instead of specifying
                       separate files for the management server. If not given, the value is
                       inherited from HTTP options. Relevant only when something is exposed on the
                       management interface - see the guide for details. Available only when
                       http-management-scheme is inherited.
--https-management-key-store-password <password>
                     The password of the key store file for the management server. If not given,
                       the value is inherited from HTTP options. Relevant only when something is
                       exposed on the management interface - see the guide for details. Default:
                       password. Available only when http-management-scheme is inherited.
--legacy-observability-interface <true|false>
                     DEPRECATED. If metrics/health endpoints should be exposed on the main HTTP
                       server (not recommended). If set to true, the management interface is
                       disabled. Default: false.

Metrics:

--metrics-enabled <true|false>
                     If the server should expose metrics. If enabled, metrics are available at the
                       '/metrics' endpoint. Default: false.

Proxy:

--proxy-headers <headers>
                     The proxy headers that should be accepted by the server. Misconfiguration
                       might leave the server exposed to security vulnerabilities. Takes precedence
                       over the deprecated proxy option. Possible values are: forwarded, xforwarded.
--proxy-protocol-enabled <true|false>
                     Whether the server should use the HA PROXY protocol when serving requests from
                       behind a proxy. When set to true, the remote address returned will be the
                       one from the actual connecting client. Cannot be enabled when the
                       `proxy-headers` is used. Default: false.
--proxy-trusted-addresses <trusted proxies>
                     A comma separated list of trusted proxy addresses. If set, then proxy headers
                       from other addresses will be ignored. By default all addresses are trusted.
                       A trusted proxy address is specified as an IP address (IPv4 or IPv6) or
                       Classless Inter-Domain Routing (CIDR) notation. Available only when
                       proxy-headers is set.

Vault:

--vault <provider>   Enables a vault provider. Possible values are: file, keystore.
--vault-dir <dir>    If set, secrets can be obtained by reading the content of files within the
                       given directory.
--vault-file <file>  Path to the keystore file.
--vault-pass <pass>  Password for the vault keystore.
--vault-type <type>  Specifies the type of the keystore file. Default: PKCS12.

Logging:

--log <handler>      Enable one or more log handlers in a comma-separated list. Possible values
                       are: console, file, syslog. Default: console.
--log-async <true|false>
                     Indicates whether to log asynchronously to all handlers. Default: false.
--log-console-async <true|false>
                     Indicates whether to log asynchronously to console. If not set, value from the
                       parent property 'log-async' is used. Default: false. Available only when
                       Console log handler is activated.
--log-console-color <true|false>
                     Enable or disable colors when logging to console. If this is not present then
                       an attempt will be made to guess if the terminal supports color. Available
                       only when Console log handler is activated.
--log-console-format <format>
                     The format of unstructured console log entries. If the format has spaces in
                       it, escape the value using "<format>". Default: %d{yyyy-MM-dd HH:mm:ss,SSS} %
                       -5p [%c] (%t) %s%e%n. Available only when Console log handler is activated.
--log-console-level <level>
                     Set the log level for the console handler. It specifies the most verbose log
                       level for logs shown in the output. It respects levels specified in the
                       'log-level' option, which represents the maximal verbosity for the whole
                       logging system. For more information, check the Logging guide. Possible
                       values are (case insensitive): off, fatal, error, warn, info, debug, trace,
                       all. Default: all. Available only when Console log handler is activated.
--log-console-output <output>
                     Set the log output to JSON or default (plain) unstructured logging. Possible
                       values are: default, json. Default: default. Available only when Console log
                       handler is activated.
--log-level <category:level>
                     The log level of the root category or a comma-separated list of individual
                       categories and their levels. For the root category, you don't need to
                       specify a category. Default: info.
--log-level-<category> <level>
                     The log level of a category. Takes precedence over the 'log-level' option.
                       Possible values are (case insensitive): off, fatal, error, warn, info,
                       debug, trace, all.
--log-mdc-enabled <true|false>
                     Indicates whether to add information about the realm and other information to
                       the mapped diagnostic context. All elements will be prefixed with 'kc.'
                       Default: false. Available only when log-mdc preview feature is enabled.

Tracing:

--tracing-enabled <true|false>
                     Enables the OpenTelemetry tracing. Default: false. Available only when
                       'opentelemetry' feature is enabled.

Truststore:

--tls-hostname-verifier <tls-hostname-verifier>
                     The TLS hostname verification policy for out-going HTTPS and SMTP requests.
                       ANY should not be used in production. Possible values are: ANY, WILDCARD
                       (deprecated), STRICT (deprecated), DEFAULT. Default: DEFAULT.
--truststore-paths <truststore-paths>
                     List of pkcs12 (p12, pfx, or pkcs12 file extensions), PEM files, or
                       directories containing those files that will be used as a system truststore.

Security:

--fips-mode <mode>   Sets the FIPS mode. If 'non-strict' is set, FIPS is enabled but on
                       non-approved mode. For full FIPS compliance, set 'strict' to run on approved
                       mode. This option defaults to 'disabled' when 'fips' feature is disabled,
                       which is by default. This option defaults to 'non-strict' when 'fips'
                       feature is enabled. Possible values are: non-strict, strict. Default:
                       disabled.

Bootstrap Admin:

--bootstrap-admin-client-id <client id>
                     Client id for the temporary bootstrap admin service account. Used only when
                       the master realm is created. Available only when bootstrap admin client
                       secret is set. Default: temp-admin.
--bootstrap-admin-client-secret <client secret>
                     Client secret for the temporary bootstrap admin service account. Used only
                       when the master realm is created. Use a non-CLI configuration option for
                       this option if possible.
--bootstrap-admin-password <password>
                     Temporary bootstrap admin password. Used only when the master realm is
                       created. Use a non-CLI configuration option for this option if possible.
--bootstrap-admin-username <username>
                     Temporary bootstrap admin username. Used only when the master realm is
                       created. Available only when bootstrap admin password is set. Default:
                       temp-admin.